/**
 *
 */
/*!
 * © 2014 David Vines
 *
 * Creative Commons License
 *
 * This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
 */

Date.prototype.getUTCDayOfYear = Date.prototype.getUTCDayOfYear || function() {
    "use strict";
    var onejan = new Date(this.getUTCFullYear(), 0, 1);
    return Math.ceil((this - onejan + 1) / 86400000); // We add a millisecond to get midnight onto the next day
};
Date.prototype.getUTCDayFraction = Date.prototype.getUTCDayFraction || function() {
    "use strict";
    return this.getUTCHours() / 24 + this.getUTCMinutes() / 1440;
};
Date.prototype.getTékumelJulian = Date.prototype.getTékumelJulian || function() {
    "use strict";
    return (this.getUTCFullYear() - 1974 + 2354) * 365 + this.getUTCDayOfYear() - 1 + this.getUTCDayFraction() + (this.getUTCFullYear() - 1974 + 2354) / 4;
};
Date.prototype.toTékumelYear = Date.prototype.toTékumelYear || function() {
    "use strict";
    return this.getUTCFullYear() - 1974 + 2354;
};
Date.prototype.toTékumelDayString = Date.prototype.toTékumelDayString || function() {
    "use strict";
    var doy = this.getUTCDayOfYear();
    if (doy < 361) {
        var dom = ((doy-1) % 30)+1;
        var month = Math.floor((doy-1) / 30);
        return dom + " " + ["Hasanpór","Shápru","Didóm","Langála","Fésru","Drénggar","Firasúl","Pardán","Halír","Trantór","Lésdrim","Dohála"][month];
    } else {
        var dof = doy - 361;
        return ["Ikáner","Turugdáshe","Vraháma","Ngaqómi","Chitlásha","Koluméhagi"][dof];
    }
};
// Note: Festivals are attached to the last month in this numbering scheme - also first month is zero
Date.prototype.toTékumelMonth = Date.prototype.toTékumelMonth || function() {
    var doy = this.getUTCDayOfYear();
    if (doy < 360) {
        return Math.floor(doy/30);
    } else {
        return 11;
}
};
Date.prototype.toTékumelJulianMonth = Date.prototype.toTékumelJulianMonth || function() {
    return this.toTékumelYear()*12 + this.toTékumelMonth();
};
Date.prototype.toTékumelMonthString = Date.prototype.toTékumelMonthString || function(i) {
    if (i === undefined) { i = this.toTékumelMonth(); }
    i = i % 12;
    var names = ["Hasanpór","Shápru","Didóm","Langála","Fésru","Drénggar","Firasúl","Pardán","Halír","Trantór","Lésdrim","Dohála"];
    return names[i];
};
Date.prototype.toTékumelString = Date.prototype.toTékumelString || function() {
    "use strict";
    return this.toTékumelDayString() + " " + this.toTékumelYear() + " at " + this.toLocaleTimeString();
};
